package starfleet;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class StarfleetManagerTester {


	public static void main(String[] args) {

		System.out.println("*** STARFLEET COMMAND OFFICIAL REPORT ***\n");

		List<Spaceship> fleet = generateStarfleet();

		System.out.println("Fleet Ships by Commission Year:");
		for (String shipDescription : StarfleetManager.getSpacecraftDescriptionsByCommissionYear(fleet)) {
			System.out.println(shipDescription);
		}

		System.out.println();
		System.out.println("Ship Counts by Type:");
		for (Map.Entry<String,Integer> entry : StarfleetManager.getInstanceNumberPerClass(fleet).entrySet()) {
			System.out.println("\t" + entry.getValue() + "\t" + entry.getKey());
		}

		System.out.println();
		System.out.println("Weapon Types:");
		for (String  weaponName: StarfleetManager.getFleetWeaponNames(fleet)) {
			System.out.println("\t" + weaponName);
		}

		System.out.println();
		System.out.println("Ship names sorted by annual maintenance cost:");
		for (String  shipName: StarfleetManager.getShipsNamesSortedByMaintenanceCost(fleet)) {
			System.out.println("\t" + shipName);
		}


		System.out.println();
		System.out.println("Fleet Totals:");
		System.out.println("\tTotal Fire Power:              " + StarfleetManager.getTotalFleetFirePower(fleet));
		System.out.println("\tAverage Fleet Speed:           " + StarfleetManager.getFleetAverageOfMaximalSpeed(fleet));
		System.out.println("\tTotal Annual Maintenance Cost: " + StarfleetManager.getTotalMaintenanceCost(fleet));

	}

	public static List<Spaceship> generateStarfleet() {
		List<Spaceship> fleet = new ArrayList<>();

		fleet.add(new MedicalShip("USS Pasteur", 2451,7.2f, 8));
		fleet.add(new MedicalShip("USS Fleming", 2532,4.5f, 12));

		List<Weapon> weapons = new ArrayList<Weapon>();
		weapons.add(new Weapon("Laser Canons",10,100));
		weapons.add(new Weapon("Photon Torpedoes",100,200));
		fleet.add(new Fighter("USS Excalibur",2423,6f, weapons));

		weapons = new ArrayList<Weapon>();
		weapons.add(new Weapon("Laser Canons",10,100));
		weapons.add(new Weapon("Quantum Torpedoes",120,200));
		weapons.add(new Weapon("TAU Phasers",150,280));
		fleet.add(new Destroyer("USS Enterprise",2416,9.9f, weapons,5));

		fleet.add(new TransportShip("USS Peres", 2396, 5.1f, 2000,5000));

		fleet.add(new CargoTransportShip("USS Lantree", 24571, 5.1f, 3000,10000,3));

		return fleet;
	}

}
